import { world, system, ItemStack, TicksPerSecond} from '@minecraft/server';






system.runInterval(()=>
{

    var entities = world.getDimension("overworld").getEntities()
    var dimension = world.getDimension("overworld")
    
    for (let i = 0; i < entities.length; i++)
    {
        if (entities[i].typeId != "minecraft:item" && entities[i].isValid())
        {
            if ((dimension.getBlock({x: entities[i].location.x, y: entities[i].location.y, z: entities[i].location.z}) != undefined))
            {
                if (dimension.getBlock({x: entities[i].location.x, y: entities[i].location.y, z: entities[i].location.z}).typeId == "msls:barbed_wire_block")
                {
                    
                    entities[i].applyDamage(2)
                    if (entities[i].getComponent("minecraft:movement") != undefined)
                    {
                        entities[i].getComponent("minecraft:movement").setCurrentValue(entities[i].getComponent("minecraft:movement").defaultValue / 3)
                    }
                    entities[i].addTag("in_barbed_wire")
                    
                    
                }
                else {
                    if (entities[i].getComponent("minecraft:movement") != undefined && entities[i].hasTag("in_barbed_wire"))
                    {
                        entities[i].getComponent("minecraft:movement").resetToDefaultValue()
                        entities[i].removeTag("in_barbed_wire")
                    }
                    
                }
            }
        }
        
    }
},
1)







world.afterEvents.blockPlace.subscribe((eventData) =>{


	let placedBlock = eventData.block;
    blockUpdate(placedBlock, false)


});

world.afterEvents.blockBreak.subscribe((eventData) =>{
    const block = eventData.block
    blockUpdate(block, true)
})

function blockUpdate(block, broken)
{
    if (broken == false)
    {
        if (block.hasTag("fence"))
        {
            fenceUpdate(block)
        }
    }
    
    const blockTop = block.dimension.getBlock({ x: block.location.x, y: block.location.y + 1, z: block.location.z})
    if (blockTop.hasTag("fence"))
    {
        fenceUpdate(blockTop)
    }
    const blockBottom = block.dimension.getBlock({ x: block.location.x, y: block.location.y - 1, z: block.location.z})
    if (blockBottom.hasTag("fence"))
    {
        fenceUpdate(blockBottom)
    }
    const blockNorth = block.dimension.getBlock({ x: block.location.x, y: block.location.y, z: block.location.z  - 1})
    if (blockNorth.hasTag("fence"))
    {
        fenceUpdate(blockNorth)
    }
    const blockSouth = block.dimension.getBlock({ x: block.location.x, y: block.location.y, z: block.location.z + 1})
    if (blockSouth.hasTag("fence"))
    {
        fenceUpdate(blockSouth)
    }
    const blockEast = block.dimension.getBlock({ x: block.location.x  + 1, y: block.location.y, z: block.location.z})
    if (blockEast.hasTag("fence"))
    {
        fenceUpdate(blockEast)
    }
    const blockWest = block.dimension.getBlock({ x: block.location.x - 1, y: block.location.y, z: block.location.z})
    if (blockWest.hasTag("fence"))
    {
        fenceUpdate(blockWest)
    }
}

function fenceUpdate(block)
{
    let sideCount = 0;
    const thinFenceAttachable = ["minecraft:blockstone_wall", "minecraft:coobled_deepslate_wall", "minecraft:cobblestone_wall", "minecraft:deepslate_brick_wall", "minecraft:deepslate_tile_wall", "minecraft:mud_brick_wall", "minecraft:polished_blackstone_wall", "minecraft:polished_blackstone_brick_wall", "minecraft:polished_deepslate_wall", "minecraft:iron_bars"]
    let blockCheck = block.dimension.getBlock({ x: (block.location.x + 1), y: block.location.y , z: block.location.z})
    
    if (blockCheck.isSolid() == true || blockCheck.hasTag("solidEast") || blockCheck.hasTag("fence") || blockCheck.hasTag("solid") ||  thinFenceAttachable.includes(blockCheck.typeId))
    {
        var east = 1
        sideCount++
    }
    else
    {
        var east = 0
    }
    blockCheck = block.dimension.getBlock({ x: (block.location.x - 1), y: block.location.y , z: block.location.z})
    if (blockCheck.isSolid() == true || blockCheck.hasTag("solidWest") || blockCheck.hasTag("fence") || blockCheck.hasTag("solid") ||  thinFenceAttachable.includes(blockCheck.typeId))
    {
        var west = 1
        sideCount++
    }
    else
    {
        var west = 0
    }
    blockCheck = block.dimension.getBlock({ x: (block.location.x), y: block.location.y , z: (block.location.z - 1)})
    if (blockCheck.isSolid() == true || blockCheck.hasTag("solidNorth") || blockCheck.hasTag("fence") || blockCheck.hasTag("solid") ||  thinFenceAttachable.includes(blockCheck.typeId))
    {
        var north = 1
        sideCount++
    }
    else
    {
        var north = 0
    }
    blockCheck = block.dimension.getBlock({ x: (block.location.x), y: block.location.y , z: (block.location.z + 1)})
    if (blockCheck.isSolid() == true || blockCheck.hasTag("solidSouth") || blockCheck.hasTag("fence") || blockCheck.hasTag("solid") ||  thinFenceAttachable.includes(blockCheck.typeId))
    {
        var south = 1
        sideCount++
    }
    else
    {
        var south = 0
    }
    if ((east == north || west == south || west == north || east == south))
    {
        var center = 1
    }
    else
    {
        var center = 0
    }
    block.dimension.runCommandAsync(`setblock ${block.location.x } ${block.location.y } ${block.location.z } ${block.typeId} ["msls:north" = ${north}, "msls:east" = ${east}, "msls:south" = ${south}, "msls:west" = ${west}, "msls:center" = ${center}]`)
}

